import * as t from '@babel/types';
import { AppConfig, RemaxOptions, RemaxNodePlugin, ExtendsCLIOptions, ExtendsRollupConfigOptions, Entries, Meta } from 'remax-types';
declare class API {
    plugins: RemaxNodePlugin[];
    adapter: {
        name: string;
        packageName: string;
        options: {};
    };
    meta: {
        template: {
            extension: string;
            tag: string;
            src: string;
        };
        style: string;
        jsHelper: {
            extension: string;
            tag: string;
            src: string;
        };
        include: {
            tag: string;
            src: string;
        };
    };
    extendsCLI(options: ExtendsCLIOptions): import("remax-types").CLI;
    getMeta(): Meta;
    getHostComponents(): import("remax-types").HostComponents;
    getEntries(entries: Entries, appManifest: AppConfig, remaxOptions: RemaxOptions): Entries;
    processProps(componentName: string, props: string[], additional?: boolean, node?: t.JSXElement | undefined): string[];
    shouldHostComponentRegister(componentName: string, phase: 'import' | 'jsx' | 'extra', additional?: boolean): boolean;
    extendsRollupConfig(options: ExtendsRollupConfigOptions): import("remax-types").RollupOptions;
    registerAdapterPlugins(adapterName: string): void;
    registerNodePlugins(remaxConfig: RemaxOptions): void;
    private registerHostComponents;
}
declare const _default: API;
export default _default;
