"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rollup = __importStar(require("rollup"));
const API_1 = __importDefault(require("../API"));
const rollupConfig_1 = __importDefault(require("./rollupConfig"));
const getConfig_1 = __importDefault(require("../getConfig"));
const watcher_1 = __importDefault(require("./watcher"));
const output_1 = require("./utils/output");
exports.default = async (argv, context) => {
    const options = Object.assign(Object.assign({}, getConfig_1.default()), (context ? context.config : {}));
    API_1.default.registerAdapterPlugins(argv.target);
    const rollupOptions = rollupConfig_1.default(options, argv, context);
    if (argv.watch) {
        watcher_1.default(options, rollupOptions, argv, context);
        try {
            require('remax-stats').run();
        }
        catch (e) {
            // ignore
        }
    }
    else {
        try {
            output_1.output('🚀 开始 build...', 'blue');
            const bundle = await rollup.rollup(rollupOptions);
            await bundle.write(rollupOptions.output);
            output_1.output('💡 完成', 'green');
        }
        catch (error) {
            const name = error.code === 'PLUGIN_ERROR' ? error.plugin : error.code;
            output_1.output(`\n🚨 [${name}]: ${error.message}`, 'red');
            throw error;
        }
    }
};
