"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rollup_plugin_babel_1 = __importDefault(require("rollup-plugin-babel"));
const lodash_1 = require("lodash");
function processPresets(presets, babel, react) {
    const remaxPresetIndex = presets.findIndex(preset => preset.file &&
        (preset.file.resolved === require.resolve('babel-preset-remax') ||
            preset.file.request === 'remax' ||
            preset.file.request === 'babel-preset-remax'));
    const defaultOptions = {
        react,
    };
    const existOptions = remaxPresetIndex !== -1 ? presets[remaxPresetIndex].options : {};
    const remaxPreset = babel.createConfigItem([
        require.resolve('babel-preset-remax'),
        lodash_1.merge({}, defaultOptions, existOptions),
    ], {
        type: `preset`,
    });
    if (remaxPresetIndex === -1) {
        presets.unshift(remaxPreset);
    }
    else {
        presets[remaxPresetIndex] = remaxPreset;
    }
    return presets;
}
exports.default = rollup_plugin_babel_1.default.custom((babelCore) => {
    return {
        options(_a) {
            var { reactPreset, usePlugins } = _a, pluginOptions = __rest(_a, ["reactPreset", "usePlugins"]);
            return {
                customOptions: {
                    reactPreset,
                    usePlugins,
                },
                pluginOptions,
            };
        },
        config(cfg, { customOptions }) {
            const presets = processPresets(cfg.options.presets, babelCore, customOptions.reactPreset);
            return Object.assign(Object.assign({}, cfg.options), { presets, plugins: [
                    ...(cfg.options.plugins || []),
                    ...(customOptions.usePlugins || []),
                ] });
        },
    };
});
