import * as t from '@babel/types';
import { NodePath } from '@babel/traverse';
export interface Component {
    id: string;
    props: string[];
    importer: string;
    pages?: Set<string>;
}
declare type Components<T> = Map<string, T>;
export declare type Importers<T = Component> = Map<string, Components<T>>;
export declare function convertComponents<T extends Component>(importers: Importers<T>): (T & {
    props: string[];
})[];
export declare function addToComponentCollection<T extends Component>(component: T, importers: Importers): void;
declare const _default: () => {
    pre(state: any): void;
    visitor: {
        ImportDeclaration(path: NodePath<t.ImportDeclaration>, state: any): void;
        JSXElement(path: NodePath<t.Node>, state: any): void;
    };
};
export default _default;
export declare function getComponents(): (Component & {
    props: string[];
})[];
