"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const postcss_1 = __importDefault(require("postcss"));
const API_1 = __importDefault(require("../../../API"));
const util_1 = require("./util");
const output_1 = require("../../utils/output");
const cssPaths = [];
exports.walk = (filePath) => {
    if (!fs_1.existsSync(filePath)) {
        return;
    }
    util_1.pushArray(cssPaths, filePath);
    const content = fs_1.readFileSync(filePath);
    const ast = postcss_1.default.parse(content);
    if (!ast.nodes) {
        return;
    }
    ast.nodes.forEach(node => {
        if (node.type === 'atrule' && node.name === 'import') {
            const file = util_1.getPath(filePath, node.params.replace(/'|"/g, ''));
            if (!fs_1.existsSync(file)) {
                output_1.output(`\n🚨 文件 ${file} 不存在`, 'red');
                return;
            }
            exports.walk(file);
        }
    });
};
exports.getcssPaths = () => {
    return cssPaths;
};
exports.default = (id) => {
    const filePath = id.replace(/\.js$/, API_1.default.getMeta().style);
    exports.walk(filePath);
};
