"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const htmlparser2 = __importStar(require("htmlparser2"));
const fs_1 = __importDefault(require("fs"));
const API_1 = __importDefault(require("../../../API"));
const util_1 = require("./util");
const output_1 = require("../../utils/output");
const parser = new htmlparser2.Parser({});
const templatePaths = [];
function walk(filePath) {
    if (!fs_1.default.existsSync(filePath)) {
        output_1.output(`\n🚨 文件 ${filePath} 不存在`, 'red');
        return;
    }
    const meta = API_1.default.getMeta();
    const { tag, src } = meta.template;
    const { tag: includeTag, src: includeSrc } = meta.include;
    util_1.pushArray(templatePaths, filePath);
    const content = fs_1.default.readFileSync(filePath).toString();
    parser._cbs.onopentag = (name, attrs) => {
        if (name === tag && attrs[src]) {
            walk(util_1.getPath(filePath, attrs[src]));
        }
        else if (name === includeTag && attrs[includeSrc]) {
            walk(util_1.getPath(filePath, attrs[includeSrc]));
        }
    };
    parser.reset();
    parser.write(content);
    parser.end();
}
exports.walk = walk;
exports.getTemplatePaths = () => {
    return templatePaths;
};
exports.default = (id) => {
    const filePath = id.replace(/\.js$/, API_1.default.getMeta().template.extension);
    walk(filePath);
};
