"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./util");
const fs_1 = require("fs");
const path_1 = __importDefault(require("path"));
const output_1 = require("../../utils/output");
const runWalk = (filePath, options, ctx) => {
    const walk = (filePath) => {
        delete require.cache[filePath];
        const { usingComponents = {} } = require(filePath);
        Object.values(usingComponents).forEach(value => {
            const componentPath = util_1.getPath(filePath, value);
            const componentJsPath = `${componentPath}.js`;
            const componentJsonPath = `${componentPath}.json`;
            if (!fs_1.existsSync(componentJsPath) || !fs_1.existsSync(componentJsonPath)) {
                output_1.output(`\n🚨 ${componentJsPath} 或 ${componentJsonPath} 不存在`, 'red');
                return;
            }
            ctx.emitFile({
                id: path_1.default.relative(options.cwd, componentJsPath),
                type: 'chunk',
            });
            walk(componentJsonPath);
        });
    };
    walk(filePath);
};
function usingComponents(id, options, ctx) {
    const filePath = id.replace(/\.js$/, '.json');
    if (!fs_1.existsSync(filePath)) {
        output_1.output(`\n🚨 文件 ${filePath} 不存在`, 'red');
        return;
    }
    runWalk(filePath, options, ctx);
}
exports.default = usingComponents;
