"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const mkdirp_1 = __importDefault(require("mkdirp"));
const path_1 = __importDefault(require("path"));
const postcss_url_1 = __importDefault(require("postcss-url"));
const winPath_1 = __importDefault(require("../../winPath"));
function postcssUrl(options) {
    var _a, _b, _c, _d, _e, _f, _g;
    function copy(asset) {
        const srcPath = path_1.default.join(options.cwd, options.rootDir, asset.url);
        const destPath = path_1.default.join(options.cwd, options.output, asset.url);
        fs_1.default.exists(srcPath, exists => {
            if (!exists) {
                return;
            }
            mkdirp_1.default(path_1.default.dirname(destPath), () => {
                if (!fs_1.default.existsSync(destPath)) {
                    fs_1.default.copyFileSync(srcPath, destPath);
                }
            });
        });
        if (/^\.{1,2}\/|^\w+\//.test(asset.url)) {
            return winPath_1.default(`/${path_1.default.relative(path_1.default.resolve(options.cwd, options.rootDir), asset.absolutePath)}`);
        }
        return asset.url;
    }
    return postcss_url_1.default(Object.assign(Object.assign({}, (_b = (_a = options.postcss) === null || _a === void 0 ? void 0 : _a.url, (_b !== null && _b !== void 0 ? _b : {}))), { url: ((_d = (_c = options.postcss) === null || _c === void 0 ? void 0 : _c.url) === null || _d === void 0 ? void 0 : _d.inline) ? 'inline' : copy, maxSize: (_g = (_f = (_e = options.postcss) === null || _e === void 0 ? void 0 : _e.url) === null || _f === void 0 ? void 0 : _f.maxSize, (_g !== null && _g !== void 0 ? _g : 8)), fallback: copy, basePath: path_1.default.resolve(options.cwd, options.rootDir), assetsPath: path_1.default.resolve(options.cwd, options.output) }));
}
exports.default = postcssUrl;
