import { OutputAsset, Plugin } from 'rollup';
import { RemaxOptions } from 'remax-types';
interface Node {
    start: number;
    end: number;
    type: NodeType;
    [additional: string]: any;
}
declare enum NodeType {
    Literal = "Literal",
    CallExpresssion = "CallExpression",
    Identifier = "Identifier",
    ImportDeclaration = "ImportDeclaration",
    ExportNamedDeclaration = "ExportNamedDeclaration",
    ExportAllDeclaration = "ExportAllDeclaration"
}
export declare function isAsset(module: any): module is OutputAsset;
export declare function getImportSource(node: Node): Node | false;
export declare function getRequireSource(node: Node): Node | false;
export default function removeSrc(options: RemaxOptions): Plugin;
export {};
