import { Plugin } from 'rollup';
interface Node {
    start: number;
    end: number;
    type: NodeType;
    [additional: string]: any;
}
declare enum NodeType {
    Literal = "Literal",
    CallExpresssion = "CallExpression",
    Identifier = "Identifier",
    ImportDeclaration = "ImportDeclaration",
    ExportNamedDeclaration = "ExportNamedDeclaration",
    ExportAllDeclaration = "ExportAllDeclaration"
}
export interface RenameExtensionsOptions {
    /**
     * Files to include
     */
    include?: Array<string | RegExp> | string | RegExp | null;
    /**
     * Files to explicitly exclude
     */
    exclude?: Array<string | RegExp> | string | RegExp | null;
    /**
     * Generate source maps for the transformations.
     */
    sourceMap?: boolean;
    /**
     * Object describing the transformations to use.
     * IE. Input filename => Output filename.
     * Extensions should include the dot for both input and output.
     */
    map: (name: string) => string;
    /**
     * Match all files, include files start with '\0'
     */
    matchAll?: boolean;
}
export declare function isEmpty(array: any[] | undefined): boolean;
export declare function getRequireSource(node: Node): Node | false;
export declare function getImportSource(node: Node): Node | false;
export declare function getExportSource(node: Node): Node | false;
export declare function rewrite(input: string, map: (name: string) => string): string;
export default function rename(options: RenameExtensionsOptions): Plugin;
export {};
