"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const esm_1 = __importDefault(require("esm"));
const defaultOptions_1 = __importDefault(require("./defaultOptions"));
const schema_utils_1 = __importDefault(require("schema-utils"));
const RemaxOptionsSchema_json_1 = __importDefault(require("./RemaxOptionsSchema.json"));
function readJavascriptConfig(path) {
    // eslint-disable-next-line
    require = esm_1.default(module, {
        cjs: {
            dedefault: true,
        },
    });
    delete require.cache[require.resolve(path)];
    const config = require(path);
    return config || {};
}
function getConfig(validate = true) {
    const configPath = path_1.default.join(process.cwd(), './remax.config');
    let options = {};
    if (fs_1.default.existsSync(configPath + '.js')) {
        options = readJavascriptConfig(configPath + '.js');
    }
    if (validate) {
        schema_utils_1.default(RemaxOptionsSchema_json_1.default, options, {
            name: 'remax',
        });
    }
    return Object.assign(Object.assign({}, defaultOptions_1.default), options);
}
exports.default = getConfig;
