"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const API_1 = __importDefault(require("./API"));
var output_1 = require("./build/utils/output");
exports.logger = output_1.default;
const yargs_1 = __importDefault(require("yargs"));
const build_1 = __importDefault(require("./build"));
const checkVersions_1 = require("./checkVersions");
exports.cli = yargs_1.default;
function run(args, context, callback) {
    checkVersions_1.checkRemaxVersion();
    exports.cli = yargs_1.default
        .scriptName('remax-cli')
        .usage('Usage: $0 <command> [options]')
        .command('build', '编译项目', 
    /* istanbul ignore next */
    () => {
        // ignore
    }, (argv) => build_1.default(argv, context));
    exports.cli = API_1.default.extendsCLI({ cli: exports.cli });
    exports.cli
        .option('watch', {
        describe: '监听文件变化',
        alias: 'w',
        type: 'boolean',
        default: false,
    })
        .option('target', {
        describe: '目标平台，如 wechat，alipay',
        alias: 't',
        type: 'string',
        required: true,
        requiresArg: true,
    })
        .showHelpOnFail(false);
    return exports.cli.parse(args, callback);
}
exports.run = run;
