"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const esm_1 = __importDefault(require("esm"));
const fs_1 = __importDefault(require("fs"));
function readTypescriptManifest(path, target) {
    require('@babel/register')({
        presets: [
            ['@babel/preset-env', { modules: 'commonjs' }],
            '@babel/preset-typescript',
        ],
        extensions: ['.ts'],
        cache: false,
    });
    // eslint-disable-next-line no-global-assign
    require = esm_1.default(module, {
        cjs: {
            dedefault: true,
        },
    });
    delete require.cache[require.resolve(path)];
    const config = require(path)[target] || require(path).default || require(path);
    return config;
}
function readJavascriptManifest(path, target) {
    // eslint-disable-next-line no-global-assign
    require = esm_1.default(module, {
        cjs: {
            dedefault: true,
        },
    });
    delete require.cache[require.resolve(path)];
    const config = require(path)[target] || require(path).default || require(path);
    return config;
}
function readManifest(path, target, strict = false) {
    const tsPath = path + '.ts';
    if (fs_1.default.existsSync(tsPath)) {
        return readTypescriptManifest(tsPath, target);
    }
    const jsPath = path + '.js';
    if (fs_1.default.existsSync(jsPath)) {
        return readJavascriptManifest(jsPath, target);
    }
    if (strict) {
        throw new Error(`${path}.ts|js 文件不存在，请先创建配置文件，参考 https://remaxjs.org/guide/config`);
    }
    return {};
}
exports.default = readManifest;
